<!-- This file was generated by pybib2web, version 0.6.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications about Interfaces for Component-Based DesignSoftware Model Checking</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications">

<li class="bibentry" id="CAV07b">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Vasu</span> <span class="lastname">Singh</span></span>.</span>
    <span class="publication-title">Algorithms for Interface Synthesis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">W.</span> <span class="lastname">Damm</span></span> and
      <span class="editor"><span class="firstname">H.</span> <span class="lastname">Hermanns</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 19th International Conference on
        Computer Aided Verification 
        (CAV 2007, Berlin, July 3-7)</em>,
      <span class="series">LNCS 4590</span>,
      <span class="pages">pages 4-19</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-73368-3_4" data-doi="10.1007/978-3-540-73368-3_4" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-73368-3_4</a>
  </span>
  <a class="bibentry-link" href="#CAV07b"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/I.html">I</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/S.html">s</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/M.html">m</a>,
        <a class="keyword" href="../Keyword/P.html">p</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/-.html">-</a>,
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/S.html">s</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/D.html">D</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/S.html">s</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-73368-3_4" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-CAV.Algorithms_for_Interface_Synthesis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        A temporal interface for a software component is a
        finite automaton that specifies the legal sequences of
        calls to functions that are provided by the component.
        We compare and evaluate three different algorithms for
        automatically extracting temporal interfaces from
        program code: (1) a game algorithm that computes the
        interface as a representation of the most general
        environment strategy to avoid a safety violation; (2)
        a learning algorithm that repeatedly queries the
        program to construct the minimal interface automaton;
        and (3) a CEGAR algorithm that iteratively refines an
        abstract interface hypothesis by adding relevant
        program variables.  For comparison purposes, we
        present and implement the three algorithms in a
        unifying formal setting.  While the three algorithms
        compute the same output and have similar worst-case
        complexities, their actual running times may differ
        considerably for a given input program.  On the
        theoretical side, we provide for each of the three
        algorithms a family of input programs on which that
        algorithm outperforms the two alternatives.  On the
        practical side, we evaluate the three algorithms
        experimentally on a variety of Java libraries.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV07b,
        author = {Dirk Beyer and Thomas A.~Henzinger and Vasu Singh},
        title = {Algorithms for Interface Synthesis},
        booktitle = {Proceedings of the 19th International Conference on Computer Aided Verification  (CAV~2007, Berlin, July 3-7)},
        editor = {W.~Damm and H.~Hermanns},
        pages = {4-19},
        year = {2007},
        series = {LNCS~4590},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-73367-6},
        doi = {10.1007/978-3-540-73368-3_4},
        sha256 = {c8d7d6300d354fb38917b44cb9fbd3ebbad1737d75107ccc124af001677679ec},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-CAV.Algorithms_for_Interface_Synthesis.pdf},
        abstract = {A temporal interface for a software component is a finite automaton that specifies the legal sequences of calls to functions that are provided by the component. We compare and evaluate three different algorithms for automatically extracting temporal interfaces from program code: (1) a game algorithm that computes the interface as a representation of the most general environment strategy to avoid a safety violation; (2) a learning algorithm that repeatedly queries the program to construct the minimal interface automaton; and (3) a CEGAR algorithm that iteratively refines an abstract interface hypothesis by adding relevant program variables.  For comparison purposes, we present and implement the three algorithms in a unifying formal setting.  While the three algorithms compute the same output and have similar worst-case complexities, their actual running times may differ considerably for a given input program.  On the theoretical side, we provide for each of the three algorithms a family of input programs on which that algorithm outperforms the two alternatives.  On the practical side, we evaluate the three algorithms experimentally on a variety of Java libraries.},
        keyword = {Interfaces for Component-Based Design,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.6.dev0</footer>